/*	TCP WRAPER	*/
/* by Marek Zelem	*/
/* All rights reserved	*/

#include <stdio.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <syslog.h>
#include <mmm/net_lib.h>
#include <mmm/text.h>
#include <stdlib.h>

char text_allow[128];
char text_deny[128];

char **arg_orig;
char **arg;
char *argp[128];

int vypis( char *fname )
{ int fd;
  char c;
	if( (fd=open(fname,O_RDONLY))<0 )	return(0);
	while( read(fd,&c,1)==1 )
		write(1,&c,1);
	close(fd);
	return(1);
}

int getword(int fd, char *word)
{ int i,r;
  char c;
	i=0; r= -1;
	while( r==-1 && read(fd,&c,1)==1 )
	{	if( i==0 && (c==' ' || c=='\t') );
		else if( c==0 || c=='\n' )	r=2;
		else if( c==' ' || c=='\t' ) r=1;
		else	word[i++]=c;
	}
	word[i]=0;
	if( r!=-1 )	return(r);
	return(0);
}

int wrapper_do( char *fname, char *user, char *host )
{ int fd,r,m,mr,g;
  char uh[128];
  char buf[128];
	sprintf(uh,"%s@%s",user,host);
	if( (fd=open(fname,O_RDONLY))<0 )
		return(-2);
	do
	{
	m=0; mr= -1;
	if( (r=getword(fd,buf))==0 )  { close(fd); return(-1); }
	else if( r==2 ) m=0;
	else
	{	if( !strcmp(buf,"ALLOW:") ) { m=1; mr=1; }
		else if( !strcmp(buf,"DENY:") )	{ m=1; mr=0; }
		else if( !strcmp(buf,"USERALLOW:") )	{ m=2; mr=1; }
		else if( !strcmp(buf,"USERDENY:") )	{ m=2; mr=0; }
		else if( !strcmp(buf,"TEXTALLOW:") )	{ m=8; }
		else if( !strcmp(buf,"TEXTDENY:") )	{ m=9; }
		else if( !strcmp(buf,"EXEC:") )
		{ int i;
		  m=100; arg=arg_orig; 
		  for(i=0;argp[i]!=NULL;i++)	free(argp[i]);
		  argp[0]=NULL;
		}
		else m= -1;
	}
//net_printf(1,"COMMAND: %s (m=%d mr=%d)\n",buf,m,mr);
	r=1; g=1;
	while( m && r && g==1 && (g=getword(fd,buf))>0 )
	{ 
//net_printf(1,"SLOVO: %s\n",buf);
		if( m==1 && wildcmp(host,buf) )	r=0;
		else if( m==2 && wildcmp(uh,buf) ) r=0;
		else if( m==8 ) {strcpy(text_allow,buf); m= -1;}
		else if( m==9 ) {strcpy(text_deny,buf); m= -1;}
		else if( m>=100 )
		{  argp[m-100]=(char *)malloc(strlen(buf)+2);
		   strcpy(argp[m-100],buf); 
		   argp[m-100+1]=NULL;
		   m++; arg=argp;
		}
	}
	} while( r && g>0 );
	close(fd);
	return(mr);
}

int main( int argc, char *argv[] )
{ int r;
  unsigned int ip;
  char fname[128],host[128],name[32],iphost[128];
  char *serv;
	arg_orig=argv;
	argp[0]=NULL;
	arg=argv;
	if( argc<1 )	return(0);
	if( !net_getpeer(0,NULL,&ip,NULL) )
	{ fprintf(stderr,"No socket!\n"); return(0); }
	net_ip2asci(ip,iphost);
	if( !net_sockident(0,host,name) )	strcpy(name,"???");
	if( !strcmp(host,iphost) )	sprintf(host,".%s",iphost);
	setenv("REMOTE_HOST",host,0);
	setenv("REMOTE_NAME",name,0);

//net_printf(1,"PID: %d\n",getpid());
	if( (serv=strrchr(argv[0],'/'))==NULL )	serv=argv[0];
	else	serv++;
	sprintf(fname,"/etc/tcpwrap/serv.%s",serv);
//net_printf(1,"filename <%s>\n",fname);
	if( (r=wrapper_do(fname,name,host))== -2 )
	{
		sprintf(fname,"/etc/tcpwrap/serv.default");
//net_printf(1,"filename <%s>\n",fname);
		r=wrapper_do(fname,name,host);
	}
	if( r<0 )
	{
		sprintf(fname,"/etc/tcpwrap/serv.all");
//net_printf(1,"filename <%s>\n",fname);
		r=wrapper_do(fname,name,host);
	}
	if( r==0 )
	{	if( text_deny[0] )	vypis(text_deny);
openlog(serv,LOG_PID,LOG_DAEMON);
syslog(LOG_INFO,"FAILED connect from %s@%s\n",name,host);
closelog();
		return(0);
	}
	if( text_allow[0] )	vypis(text_allow);
openlog(serv,LOG_PID,LOG_DAEMON);
syslog(LOG_INFO,"Connect from %s@%s\n",name,host);
closelog();
	execvp(arg[0],arg);
	return(0);
}

